#include <stdio.h>
#include <ctype.h>
#include <fcntl.h>
#include <string.h>
#include <memory.h>

#ifdef TOOLS
     /* UNIX-like tools1ƂăRpCEzzꍇ͂define
	APƂŃRpCꍇdefineȂ */
#  include "tools.h"
#else /* TOOLS */
#  include <malloc.h>
typedef	unsigned char	us_char;
typedef	unsigned int	us_int;
typedef	unsigned long	us_long;
typedef us_char	bool;
#  define setfbuf(f, b, n) setvbuf((f), (b), _IOFBF, (n))
#  define is_xdigit(c) (isascii(c) && isxdigit(c))
#  define is_digit(c) (isascii(c) && isdigit(c))
#  define is_lower(c) (isascii(c) && islower(c))
#  define ctoi(c) \
	((c) - (is_digit(c) ? '0' : is_lower(c) ? 'a' - 10 : 'A' - 10))
#  define fsetbin(f) 0
#  define s_conv_to_unix_format(s) (s)
#  define setcmdname(av0)		\
	do{				\
		if(NULL != (cmdname = strrchr(av0, '/'))) cmdname++; \
		 else cmdname = av0;	\
	} while(0)
#endif /* TOOLS */

char	*cmdname = "yakc";

#define	SI	0xf
#define	SO	0xe
#define	ESC	0x1b
#define SS2	0x8e
#define SS3	0x8f
#define ASS2	0x19 /* Alternative SS2, SS2Ɠ */
#define ASS3	0x1d /* Alternative SS3, SS3Ɠ */
#define DOSEOF	0x1a
#define	GETA	0x222e /*  */
#define	GETA_SJ	"\201\254" /*  in SJIS */
static	char	*SEQMOD = "\033&@";

#define UBUFSIZ 1024
static	int	unget_sp = 0;
static	us_int	unget_buf[UBUFSIZ];
 /* Oungetcpobt@BႤt@C݂ɓǂނƂ͂ȂƉ肵ĂB
    R[hʗpobt@p */
#define getch(inf) (unget_sp ? unget_buf[--unget_sp] : (us_int)getc(inf))
#define ungetch(c) (unget_buf[unget_sp++] = (c))
 /* ungetcĥi_eolcnvi_ignctlz̏Ȃ悤ɂĂ */
#define peekch(inf) \
	(unget_sp ? unget_buf[unget_sp - 1] : ungetch((us_int)getc(inf)))

typedef us_long	wchar4b;  /* 4oCg */
 /* 2oCgɕZbg(us_int)A2oCg͕R[h
    us_intœĂ (int4oCg̃}VłxȂ悤ɏ) */

#define whatset(c) (us_int)((c) >> 16) /* c:wchar4b */
   /* ̉2oCĝݗL
      (邢͂rmvbufinfo)0Ɛ䕶ςȕ
      ̏ꍇ*_wgetc()Ԃlgetcœꂽwchar4bcast */
#ifdef MSDOS
#  define wctoc(c) (us_int)(c) /* c:wchar4b, Ԃlus_int */
#else
#  define wctoc(c) ((us_int)(c) & 0xffff)
#endif

#define ctowc(c) (wchar4b)(c)	/* c:us_int (getc()̕Ԃlus_int) */
	 /* EOFɂ͓KpA0xffffԂƁBint4oCg̏ꍇB*/
#define uEOF ((us_int)EOF)
#define wEOF ctowc(EOF & 0xffff)
#define wEmpty (wchar4b)0

 /* wchar4b̏2oCg(us_int)ɂ */
#define TERMCHARMASK	0xff00
#define termch(x)	((x) >> 8)	/* x:us_int, 0͂ȂƑO񂵂Ă */
#define termchmask(c)	((c) << 8)	/* c:us_int, 0`127ƑO
		ԕ0x21p镶Zbgɑ΂Ă8rbgڂ𗧂Ăĕ\
		Zbgȏɑc̕Kv */
#define SETINFOMASK	0xf8
#define MULBYTECHAR	0x08	/* SS2E3Ƃ͕oCg͍̏
				   S2oCgƎvď */
#define ROMANSET	0x10	/* [}Zbgŗ */
#define JKANJITREAT	0x20	/* JISE⏕ZbgŗB݂̂Ƃ
				   ۂ2oCĝ͂ꂪꍇ
				   ASS2E3̒ł͕oCg
				   S2oCgƌȂ */
#define SPECIALSET	0x40	/* designateV[PX̏o͂ɓ
				   ʈv镶Zbg̏ꍇ
				   ݂̂ƂJIS90EPCEPCp */
#define CHARSET96	0x80
 /* ȉ̃rbg*_wgetc()̕Ԃlɂ͗iostat[n].Gbuf[m]
    iostat[n].GLR[i].setɂ͗Ȃ */
#define G0		0x00
#define G1		0x01
#define G2		0x02
#define G3		0x03 /* G0`G3͏Â */
#define SNGLSFT		0x04
#define G2_SS7bit	(0x00 | SNGLSFT)
#define G3_SS7bit	(0x01 | SNGLSFT)
#define G2_SS8bit	(0x02 | SNGLSFT)
#define G3_SS8bit	(0x03 | SNGLSFT)
 /* wctoc(c)̏ʃoCg0łȂ8rbgڂ16rbgڂقȂ
    ̂SNGLSFT̂ */
#define GBUFNUMMASK	(0x03 | SNGLSFT)
#define gbufno(x)	((x) & GBUFNUMMASK)
				/* 0`3 邢͂SNGLSFT̗ */
#define rmvbufinfo(x) ((x) & ~GBUFNUMMASK)

 /* *_wgetc()̕Ԃlɂ͗Ȃ
    ɕR[h̍ŏʃrbg */
#define GL	0
#define GR	1

#define istermch(c) ('0' <= (c) && (c) <= 0x7e) /* c:2] */
				/* {ɂł? */
#define desigch2bufno(c) (us_int)((c) - '(' + G0)
#define desig96ch2bufno(c) (us_int)((c) - '-' + G1)

#define JIS78K	 (termchmask('@') | MULBYTECHAR | JKANJITREAT)
#define JIS83K	 (termchmask('B') | MULBYTECHAR | JKANJITREAT)
#define JIS90K	 (termchmask('B') | MULBYTECHAR | JKANJITREAT | SPECIALSET)
#define PCKANJI	 (termchmask('@') | MULBYTECHAR | JKANJITREAT | SPECIALSET)
 /* JIS78K̕ό`BJIS90KƏdȂȂ悤A83K̕ό`Ƃ͂Ȃ
    G0ȊOdesignate͂߂ɂȂJIS78KƓV[PXg */
#define JISSUPK	 (termchmask('D') | MULBYTECHAR | JKANJITREAT)
 /* ⏕̕Zbg͂1 */
#define ASCIISET (termchmask('B') | ROMANSET)
#define JISROMAN (termchmask('J') | ROMANSET)
#define PCROMAN	 (termchmask('J') | ROMANSET | SPECIALSET)
 /* JISROMAN̕ό` */
#define JISKANA	 (termchmask('I'))
 /* JiZbg͂1 PC̃JiJISKANAōς܂ */
#define LATIN1SET (termchmask('A') | CHARSET96)
#define CNGBSET	  (termchmask('A') | MULBYTECHAR)
#define SWNAMSET  (termchmask('H'))
#define UNK_SET	  0 /* ꂪGbuf[n]GLR[n].setɓĂΕZbg */

 /* regularizepΉ\ */
static	unsigned char	conv21[ ] = {
	      ' ',  '\0', '\0', ',',  '.',  '\0', ':',
	';',  '?',  '!',  '\0', '\0', '\0', '\0', '\0',
	'^',  '\0', '_',  '\0', '\0', '\0', '\0', '\0',
	'\0', '\0', '\0', '\0', '\0', '\0', '\0', '/',
	'\\', '~',  '\0', '|',	'\0', '\0', '`',  '\'',
	'\0', '"',  '(',  ')',	'\0', '\0', '[',  ']',
	'{',  '}',  '\0', '\0', '\0', '\0', '\0', '\0',
	'\0', '\0', '\0', '\0', '+',  '-',  '\0', '\0',
	'\0', '=',  '\0', '<',	'>',  '\0', '\0', '\0',
	'\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0',
	'$',  '\0', '\0', '%',	'#',  '&',  '*',  '@',
	'\0', '\0', '\0', '\0', '\0', '\0', '\0',
};
static	unsigned char	convjisk[ ] = {
	      0xa3, 0xd6, 0xd7, 0xa2, 0xa6, 0x72, 0x21,
	0x23, 0x25, 0x27, 0x29, 0x63, 0x65, 0x67, 0x43,
	0xbc, 0x22, 0x24, 0x26, 0x28, 0x2a, 0x2b, 0x2d,
	0x2f, 0x31, 0x33, 0x35, 0x37, 0x39, 0x3b, 0x3d,
	0x3f, 0x41, 0x44, 0x46, 0x48, 0x4a, 0x4b, 0x4c,
	0x4d, 0x4e, 0x4f, 0x52, 0x55, 0x58, 0x5b, 0x5e,
	0x5f, 0x60, 0x61, 0x62, 0x64, 0x66, 0x68, 0x69,
	0x6a, 0x6b, 0x6c, 0x6d, 0x6f, 0x73, 0xab, 0xac,
     /*	0x70, 0x71, 0x6e, 0x75, 0x76, 0x74, 0x2c, 0x2e,
	0x30, 0x32, 0x34, 0x36, 0x38, 0x3a, 0x3c, 0x3e,
	0x40, 0x42, 0x45, 0x47, 0x49, 0x50, 0x51, 0x53,
	0x54, 0x56, 0x57, 0x59, 0x5a, 0x5c, 0x5d, */
};

 /* ͒p */
static	bool	i_eolcnv = 1, i_nobuf = 0, i_kanajis = 0, i_linemode = 0;
static	bool	i_ignctlz = 0, i_igaftctlz = 0; /* i_eolcnvxorȂ
						ĕWl߂ */
static	bool	jisk_unite = 1; /* ꂪ1Ȃ犿͑Sjisk_forceƌȂ */
 /* 0ɂĂƏo͂EUCł؂芷V[PXf */
static	us_int	jisk_force = JIS83K; /* MSR[h̊ǂ̃ZbgƌȂ? */
static	bool	roman_unite = 1; /* 1Ȃ烍[}͑Sroman_forceƌȂ */
static	us_int	roman_force = ASCIISET; /* MSR[h̃[}ǂ̃Zbg
					ȂB䕶o͎ɂg */
static	bool	swnam_as_roman = 0; /* ESC ( HESC ( JƌȂ */
#define IOtype_EUC 0
#define IOtype_JIS 1
#define IOtype_CT  2
#define IOtype_PC  3
static	int	intype_iso = IOtype_EUC, outtype_iso = IOtype_EUC;
static	us_int	kanjitreatflg = JKANJITREAT;
 /* ꂪMULBYTECHAȐꍇSS2E3̒ȊOł
    SoCg2oCgƌȂ */
	 /* o͂mscode_wputc̏ꍇ͓sɂ肱MULBYTECHARɕύX */
static	bool	k_regularize = 0, r_regularize = 0;
static	char	*initstring = NULL; /* o͂ɂe */

 /* o͒p */
#ifdef MSDOS
static	bool	o_eolcnv = 1;
#else
static	bool	o_eolcnv = 0;
#endif
static	bool	o_nobuf = 0, o_eolcr = 0;
#define	JKANA_G1GR	0		/* option 8 */ /* option P̎ */
#define	JKANA_G1GL	1		/* option 7 */
#define	JKANA_G0GL	2		/* option I */
#define	JKANA_UNDEF	-1
static	int	jkana_out = JKANA_UNDEF;
static	bool	desig4byte = 0;
#define	NONJ_Preserve	0
#define	NONJ_G0GL	1
#define	NONJ_CTtype	2
#define	NONJ_JP2type	3
#define	NONJ_EUCtype	4
#define	NONJ_UNDEF	-1
static	int	nonjset = NONJ_UNDEF;

#define ROMAN_G0GL	1
#define UNDESIG_G123	2
static	int	redsg_on_spc_out = ROMAN_G0GL, redsg_on_cr_out = ROMAN_G0GL,
		redsg_on_ctl_out = ROMAN_G0GL, redsg_on_eof_out = ROMAN_G0GL;
static	bool	redsg_on_spc_in = 0, redsg_on_cr_in = 0, redsg_on_ctl_in = 0;

static	char	*ibuf = NULL, *obuf = NULL;
#define BIGBUFSIZ 8192
static	int	ibufsiz = 0, obufsiz = 0;

#define RDSTAT	0
#define WRSTAT	1
#define STDSTAT	2
#define IOSTAT_MAX 3 /* iostat[]̓Y */
static	struct iosetinfo {
	us_int Gbuf[4]; /* G0`G3designateĂ镶Zbg */
	struct {
		us_int	bufno;	/* 0`3 */
		us_int	set;	/* Zbg */
	} GLR[2];	/* GL, GRG0`G3̂ǂꂪinvokeĂ邩 */
	 /* Gbuf[n]̍XVGLR[n].setXVKv */
} iostat[IOSTAT_MAX] /* ́Eo͂̂ꂼɂ */ = {
	{{UNK_SET, UNK_SET, JISKANA, JISSUPK}, {{G0, UNK_SET}, {G1, UNK_SET}}},
	{{UNK_SET, UNK_SET, JISKANA, JISSUPK}, {{G0, UNK_SET}, {G1, UNK_SET}}},
	{{UNK_SET, UNK_SET, JISKANA, JISSUPK}, {{G0, UNK_SET}, {G1, UNK_SET}}},
}; /* UNK_SET̏ɂjisk_force̒l */

#define Curset(io, glr) (iostat[io] . GLR[glr] . set)
#define Curbufno(io, glr) (iostat[io] . GLR[glr] . bufno)
#define Curdesig(io, bufno) (iostat[io] . Gbuf[bufno])

#define	designate_const(io, charset, buf_no)		\
	do { /* S] */			\
		Curdesig(io, buf_no) = (charset);	\
		if(Curbufno(io, GL) == (buf_no))	\
			Curset(io, GL) = (charset);	\
		if(Curbufno(io, GR) == (buf_no))	\
			Curset(io, GR) = (charset);	\
	} while(0)
#define	designate_to_thebuf(io, charset, buf_no)	\
	do { /* io, buf_no] */			\
		us_int	t_charset = (charset);		\
							\
		designate_const(io, t_charset, buf_no);	\
	} while(0) /* buf_no萔̏ꍇȂ񂩂͂g */
#define	designate_theset(io, charset, buf_no)		\
	do { /* io, charset] */		\
		us_int	t_bufno = (buf_no);		\
							\
		designate_const(io, charset, t_bufno);	\
	} while(0) /* buf_no萔̏ꍇȂ񂩂͂g */
#define designate(io, charset, buf_no)				\
	do { /* io] */					\
		us_int	t_bufno = (buf_no);			\
								\
		designate_to_thebuf(io, charset, t_bufno);	\
	} while(0)
#define invoke(io, buf_no, glr) /* S] */ \
	(Curbufno(io, glr) = (buf_no), Curset(io, glr) = Curdesig(io, buf_no))

#define in_designate_const(charset, buf_no) \
	designate_const(RDSTAT, charset, buf_no) /* S] */
#define in_designate_to_thebuf(charset, buf_no)	\
	designate_to_thebuf(RDSTAT, charset, buf_no)
	 /* buf_no]Bbuf_no萔̏ꍇ͂g */
#define in_designate_theset(charset, buf_no) \
	designate(RDSTAT, charset, buf_no) /* charset] */
#define in_designate(charset, buf_no) designate(RDSTAT, charset, buf_no)
#define in_invoke(buf_no, glr) invoke(RDSTAT, buf_no, glr) /* glr] */

#define out_designate_const(charset, buf_no) \
	designate_const(WRSTAT, charset, buf_no) /* charset, buf_no]*/
#define out_designate_to_thebuf(charset, buf_no) \
	designate_to_thebuf(WRSTAT, charset, buf_no) /* buf_no] */
#define out_invoke(buf_no, glr) invoke(WRSTAT, buf_no, glr) /* glr] */

#define makewch(c, set_buf_info) \
	(wchar4b)((us_int)(c) | ((wchar4b)(set_buf_info)) << 16)
 /* ͎wchar4b𐶐 c:us_int set_buf_info:us_int Ԃlwchar4b
    2ɂCursetCurbufnoorė^ */
#define makewchar(c, set, glr) \
	makewch((c), (set) | Curbufno(RDSTAT, (glr)))

#ifdef LSI_C
#define put2c(c, f) /* ] c:us_int */ \
	(putc((int)((c) >> 8), (f)), putc((int)(c), (f)))
#else
#define put2c(c, f) \
	(putc((int)((c) >> 8), (f)), putc((int)(c) & 0xff, (f))) /* Ö */
#endif

static	wchar4b	iso_wgetc(), mscode_wgetc(), muleint_wgetc(), special_wgetc();
static	void	iso_wputc(), eucj_wputc(), mscode_wputc();
static	wchar4b	(*common_wgetc)() = NULL, (*wgetc)() = NULL,
		(*plain_wgetc)() = NULL;
#ifdef MSDOS
static	void	(*wputc)() = mscode_wputc;
#else
static	void	(*wputc)() = eucj_wputc;
#endif
static	wchar4b	get_SS23_next(), get_ESC_next(), get_ESC_next_misc();
static	void	wchar_out(), decide_incode(), alloc_iobufs(), setinit(), yakc();

static	void	usage()
{
	fputs("Usage: ", stderr), fputs(cmdname, stderr);
	fputs("\
 [-i eujcmsPitzZlfk] [-o eujcmsPtTf] [-j @B+p] [-r JBpH1] [-k I782]\
\n\t    [-c lsoLSOe] [-C lso] [-f EIC2p] [-u 4] [-s initial] [filename...]\n",
	  stderr);
	exit(1);
}

static	void	cmd_errmsg(s)
char	*s;
{
	fputs(cmdname, stderr), fputs(": ", stderr), fputs(s, stderr);
}

static	void	cantbuf()
{
	cmd_errmsg("Can't setvbuf()\n"), exit(1);
}

static	wchar4b	iso_wgetc(inf)
FILE	*inf;
 /* {ꊿȊO̕oCg1oCgBASS2E3̎
    2oCg */
{
	register us_int	c, d;
	us_int	chset;

resume:
	c = getch(inf); /* cus_intɂcEOFȂ炻0xff */
	if(c <= 0x7e){
		if(c < 0x21) switch(c){
		case 0x20:
			chset = Curset(RDSTAT, GL);
			if(chset & CHARSET96) return makewchar(c, chset, GL);
			 /* FALLTHROUGH */
		case '\t':
			if(redsg_on_spc_in){
				in_designate_const(roman_force, G0);
				in_invoke(G0, GL);
			}
			goto other_ch1;
		case ESC:
#ifndef MSC51
#  define treat_ESC(inf)				\
	do {						\
		wchar4b	tmp = get_ESC_next(inf);	\
							\
		switch(tmp){				\
		case wEmpty:				\
			goto resume;			\
		case wEOF:				\
			break;				\
		default:				\
			return tmp;			\
		}					\
	} while(0)
#else /* MSC51switch̏case̒萔longgȂBR */
#  define treat_ESC(inf)				\
	do {						\
		wchar4b	tmp = get_ESC_next(inf);	\
							\
		if(tmp == wEmpty) goto resume;		\
		if(tmp != wEOF) return tmp;		\
	} while(0)
#endif
			treat_ESC(inf);
			goto other_ch;
		case '\r':
			if(i_eolcnv && (c = getch(inf)) != '\n')
				(ungetch(c), c = '\n');
			 /* FALLTHROUGH */
		case '\n': case '\f':
			if(redsg_on_cr_in){
				in_designate_const(roman_force, G0);
				in_invoke(G0, GL);
			}
			goto other_ch1;
		case SI:
			in_invoke(G0, GL); goto resume;
		case SO:
			in_invoke(G1, GL); goto resume;
		case ASS2:
			goto CaseSS2;
		case ASS3:
			goto CaseSS3;
		case DOSEOF:
			if(i_igaftctlz) return wEOF;
			if(i_ignctlz) goto resume;
			 /* FALLTHROUGH */
		default:
		other_ch:
			if(redsg_on_ctl_in){
				in_designate_const(roman_force, G0);
				in_invoke(G0, GL);
			}
		other_ch1:
			return ctowc(c);
		} else {
			chset = Curset(RDSTAT, GL);
			if(chset & kanjitreatflg){
				d = getch(inf);
				if(0x21 <= d && d <= 0x7e){
					return makewchar((c << 8) | d,
								chset, GL);
				} else {
					ungetch(d);
					goto other_ch;
				}
			} else {
			 /* JISKANA0x5fȉɌƂʈ͂߂ */
				return makewchar(c, chset, GL);
			}
		}
	} else {
		if(0xa1 <= c && c <= 0xfe){
			chset = Curset(RDSTAT, GR);
			if(chset & kanjitreatflg){
				d = getch(inf);
				if(0xa1 <= d && d <= 0xfe){
					return makewchar(((c << 8) | d),
								chset, GR);
				} else {
					ungetch(d);
					goto other_ch;
				}
			} else {
				return makewchar(c, chset, GR);
			}
		} else
		if(intype_iso == IOtype_PC &&
		   JISKANA == (chset = Curset(RDSTAT, GR)) &&
		   0x80 <= c && c <= 0xff){
		 /* Ji: ͂PC^̏ꍇ0x80`0xff͑SJi */
			return makewchar(c, chset, GR);
		} else switch(c) { /* 0x7f`0xa0, 0xff, EOF */
		case SS2:
		case SS3:
		CaseSS2:
		CaseSS3:
#define treat_SS23(inf, bufno, use8)			\
	do {						\
		wchar4b	tmp;				\
							\
		tmp = get_SS23_next(inf, bufno, use8);	\
		if(tmp != wEOF) return tmp;		\
	} while(0)
			treat_SS23(inf,
				(c == SS3 || c == ASS3) ? G3 : G2, c & 0x80);
			goto other_ch;
		case uEOF:
			return wEOF;
		case 0x7f:
			chset = Curset(RDSTAT, GL);
			if(chset & CHARSET96) return makewchar(c, chset, GL);
			goto other_ch;
		case 0xa0:
		case 0xff:
			chset = Curset(RDSTAT, GR);
			if(chset & CHARSET96) return makewchar(c, chset, GR);
			 /* FALLTHROUGH */
		default:
			goto other_ch;
		}
	}
}

static	wchar4b	get_SS23_next(inf, bufno, use8)
FILE	*inf;
us_int	bufno;
us_int	use8; /* 8rbgSS2E3ŌĂяoꂽ?(1or0łȂ0or0) */
 /* ςȕ߂wEOFԂBȊȌꍇwEOFԂ邱Ƃ͂ȂB܂
    0ԂȂBSNGLSFTrbgƏI[񂪔0̂͂Ȃ̂ */
{
	register us_int	c, d;
	us_int	chset = Curdesig(RDSTAT, bufno);
	us_int	set_buf_info;

	if(use8){
		set_buf_info = (bufno == G3 ? G3_SS8bit : G2_SS8bit);
	} else {
		set_buf_info = (bufno == G3 ? G3_SS7bit : G2_SS7bit);
	}
	set_buf_info |= chset;

	c = getch(inf);
	if(0x21 <= c && c <= 0x7e || 0xa1 <= c && c <= 0xfe){
		if(chset & MULBYTECHAR){
			d = getch(inf);
			if(0x21 <= d && d <= 0x7e || 0xa1 <= d && d <= 0xfe){
				return makewch(((c << 8) | d), set_buf_info);
			} else {
				ungetch(d);
				goto other_ch;
			}
		} else {
			return makewch(c, set_buf_info);
		}
	} else
    /* Ji
	if(intype_iso == IOtype_PC &&
	   chset == JISKANA && 0x80 <= c && c <= 0xff){
		return makewch(c, set_buf_info);
	} else
    */
	if(c != uEOF && (c & 0x60)){ /* 0x20, 0x7f, 0xa0, 0xff */
		if(chset & CHARSET96){
			if(chset & MULBYTECHAR){
				d = getch(inf);
				if(d != uEOF && (d & 0x60)){
				 /* 0x20`0x7f, 0xa0`0xff */
					return makewch(((c << 8) | d),
								set_buf_info);
				} else {
					ungetch(d);
					goto other_ch;
				}
			} else {
				return makewch(c, set_buf_info);
			}
		} else {
			goto other_ch;
		}
	} else {
	other_ch:
		ungetch(c);
		return wEOF;
	}
}

static	wchar4b	get_ESC_next(inf)
FILE	*inf;
 /* ςȂ̂߂wEOFAƂV[PXwEmptyA
    SS2E3ŕǂ񂾂炻̕Ԃ */
{
	register us_int	c, d;
	us_int	e;
	bool	modflg = 0; /* KiCtO */

resume:
	c = getch(inf);
	switch(c){
	case '$':
		d = getch(inf);
		switch(d){
		case 'B':
			in_designate_to_thebuf(jisk_unite ? jisk_force :
						modflg ? JIS90K : JIS83K, G0);
			return wEmpty;
		case '@':
			in_designate_to_thebuf(
				jisk_unite ? jisk_force : JIS78K, G0);
			return wEmpty;
		case 'A':
			in_designate_const(CNGBSET, G0);
			return wEmpty;
		case '(': case ')': case '*': case '+':
			e = getch(inf);
			switch(e){
			case 'B':
				in_designate(jisk_unite ? jisk_force :
						modflg ? JIS90K : JIS83K,
					desigch2bufno(d));
				return wEmpty;
			case '@':
				in_designate(jisk_unite ? jisk_force : JIS78K,
				  desigch2bufno(d));
				return wEmpty;
			case 'D':
				in_designate_theset(JISSUPK, desigch2bufno(d));
				return wEmpty;
			}
			if(istermch(e)){
				in_designate(termchmask(e) | MULBYTECHAR,
							desigch2bufno(d));
				return wEmpty;
			}
			ungetch(e);
			break;
		case ',': case '-': case '.': case '/':
			e = getch(inf);
			if(istermch(e)){
				in_designate(termchmask(e) | MULBYTECHAR |
					      CHARSET96, desig96ch2bufno(d));
				return wEmpty;
			}
			ungetch(e);
			break;
		}
		ungetch(d);
		goto other_ch;
	case '(': case ')': case '*': case '+':
		d = getch(inf);
		switch(d){
		case 'B':
			in_designate(roman_unite ? roman_force : ASCIISET,
							desigch2bufno(c));
			return wEmpty;
		case 'J':
			in_designate(roman_unite ? roman_force : JISROMAN,
							desigch2bufno(c));
			return wEmpty;
		case 'H':
			in_designate(!swnam_as_roman ? SWNAMSET :
				     roman_unite ? roman_force : JISROMAN,
					desigch2bufno(c));
			return wEmpty;
		}
		if(istermch(d)){
			in_designate(termchmask(d), desigch2bufno(c));
			return wEmpty;
		}
		if(d == '!'){ /* o^ςݑ2ԕ2/194}`() */
			e = getch(inf);
			if(istermch(e)){
				in_designate(termchmask(e | 0x80),
							desigch2bufno(c));
				return wEmpty;
			}
			ungetch(e);
		}
		ungetch(d);
		goto other_ch;
	case ',': case '-': case '.': case '/':
		d = getch(inf);
		if(istermch(d)){
			in_designate(termchmask(d) | CHARSET96,
							desig96ch2bufno(c));
			return wEmpty;
		}
		ungetch(d);
		goto other_ch;
	case '&': /* ESC & @ ESC $ B */
		d = getch(inf);
		if(d == '@'){
			e = getch(inf);
			if(e == ESC){
				modflg = 1;
				goto resume;
			}
			ungetch(e);
		}
		ungetch(d);
		goto other_ch;
	default: /* LSI COut of memoryh~̈get_ESC_next_misc()𕪊*/
		return get_ESC_next_misc(inf, c);
	}
other_ch:
	ungetch(c);
	return wEOF;
}

 /* ̒xŃG[NȂ > LSI_C */
static	wchar4b	get_ESC_next_misc(inf, c)
FILE	*inf;
us_int	c;
 /* cςȂ̂߂wEOFAƂV[PX0A
    SS2E3ŕǂ񂾂炻̕Ԃ */
{
	us_int	d;

	switch(c){
	case 'N':
	case 'O':
		treat_SS23(inf, c == 'N' ? G2 : G3, 0);
		goto other_ch;
	case 'n':
		in_invoke(G2, GL); return wEmpty;
	case 'o':
		in_invoke(G3, GL); return wEmpty;
	case '~':
		in_invoke(G1, GR); return wEmpty;
	case '}':
		in_invoke(G2, GR); return wEmpty;
	case '|':
		in_invoke(G3, GR); return wEmpty;
	case '!': case '"': case ' ':
		d = getch(inf);
		if(d != uEOF) return wEmpty;
		ungetch(d);
		goto other_ch;
	case 'K':
		in_designate_to_thebuf(jisk_unite ? jisk_force : PCKANJI, G0);
		return wEmpty;
	case 'H':
		in_designate_to_thebuf(roman_unite? roman_force : PCROMAN, G0);
		return wEmpty;
	case '\1': /* ??? */
		return wEmpty;
	}
other_ch:
	ungetch(c);
	return wEOF;
}

static	wchar4b	mscode_wgetc(inf)
FILE	*inf;
{
	us_int	c, d;
#ifndef __WATCOMC__
#  define intcast(x) ((int)(x))
#else /* WATCOMC͒萔intւcastɕtB]vȂb */
#  define intcast(x) ((int)((x) & 0xffff))
#endif
#define mssubconst(x, y, z) intcast((((long)(x) << 9) | (y)) - (z))
	static	int	mssubparam1[ ] = {
		mssubconst(0x81, 0x40, 0x2121),
		mssubconst(0x81, 0x80, 0x2160),
		mssubconst(0x81, 0x9f, 0x2221),
	};
	static	int	mssubparam2[ ] = {
		mssubconst(0xe0, 0x40, 0x5f21),
		mssubconst(0xe0, 0x80, 0x5f60),
		mssubconst(0xe0, 0x9f, 0x6021),
	};
	static	int	mssubparam3[ ] = {
		mssubconst(0xf0, 0x40, 0x2121),
		mssubconst(0xf0, 0x80, 0x2160),
		mssubconst(0xf0, 0x9f, 0x2221),
	};
	int	*mssubparam;

#define paramsub_bycase(d, param)		\
	if((d) < 0x40) goto unget_otherch;	\
	else if((d) <= 0x7e) (d) -= (param)[0];	\
	else if((d) == 0x7f) goto unget_otherch;\
	else if((d) <= 0x9e) (d) -= (param)[1];	\
	else if((d) <= 0xfc) (d) -= (param)[2];	\
	else goto unget_otherch

resume:
	c = getch(inf);
	if(0x81 <= c){ /* cus_intɂcEOFȂ炻0xff */
		if(c <= 0x9f){
			mssubparam = mssubparam1;
			goto mskanji;
		} else
		if(c <= 0xdf){
			if(c == 0xa0) return ctowc(' ');
			return makewch(c & ~0x80, JISKANA | G0);
		} else
		if(c <= 0xef){
			mssubparam = mssubparam2;
		mskanji:
			d = getch(inf);
			paramsub_bycase(d, mssubparam);
			return makewch(d + (c << 9), jisk_force | G0);
		} else
		if(c <= 0xfc){
		 /* O⏕ɂ̂͂߂? */
			d = getch(inf);
			paramsub_bycase(d, mssubparam3);
			return makewch(d + (c << 9), JISSUPK | G0);
		} else
		if(c == uEOF){
			return wEOF;
		} else { /* 0xfd`0xff */
			goto other_ch;
		}
	unget_otherch:
		ungetch(d);
		goto other_ch;
	} else
	if(0x21 <= c){
		if(c <= 0x7e) return makewch(c, roman_force | G0);
		goto other_ch;
	} else switch(c){
	case '\r':
		if(i_eolcnv && (c = getch(inf))!= '\n') (ungetch(c), c = '\n');
		goto other_ch;
	case DOSEOF:
		if(i_igaftctlz) return wEOF;
		if(i_ignctlz) goto resume;
		 /* FALLTHROUGH */
	default:
	other_ch:
		return ctowc(c);
	}
}

static	wchar4b	muleint_wgetc(inf) /* {Zbĝ */
FILE	*inf;
{
	us_int	c, d;

#define MULE_KANA_RDNG	0x89
#define MULE_KNJ_RDNG	0x92
#define MULE_SUPK_RDNG	0x94

resume:
	c = getch(inf);

	if(0x21 <= c && c <= 0x7f){
		return makewch(c, roman_force | G0);
	} else switch(c){
	case MULE_KNJ_RDNG:
		d = getch(inf);
		if(0xa1 <= d && d <= 0xfe){
			us_int	e;

			e = getch(inf);
			if(0xa1 <= e && e <= 0xfe){
				return makewch((d << 8) | e, jisk_force | G0);
			}
			ungetch(e);
		}
		ungetch(d);
		goto other_ch;
	case MULE_SUPK_RDNG:
		d = getch(inf);
		if(0xa1 <= d && d <= 0xfe){
			us_int	e;

			e = getch(inf);
			if(0xa1 <= e && e <= 0xfe){
				return makewch((d << 8) | e, JISSUPK | G0);
			}
			ungetch(e);
		}
		ungetch(d);
		goto other_ch;
	case MULE_KANA_RDNG:
		d = getch(inf);
		if(0xa1 <= d && d <= 0xdf){ /* muleint̏ꍇ0xa0l */
			return makewch(d, JISKANA | G0);
		}
		ungetch(d);
		goto other_ch;
	case uEOF:
		return wEOF;
	case '\r':
		if(i_eolcnv && (c = getch(inf))!= '\n') (ungetch(c), c = '\n');
		goto other_ch;
	case DOSEOF:
		if(i_igaftctlz) return wEOF;
		if(i_ignctlz) goto resume;
		 /* FALLTHROUGH */
					 /* 2muleintɂ͕svȂ */
	default:
	other_ch:
		return ctowc(c);
	}
}

static	wchar4b	special_wgetc(inf)
FILE	*inf;
{
	wchar4b	wc;
	us_int	c, chset;

	wc = plain_wgetc(inf);
	if(wc == wEOF) return wc;

	c = wctoc(wc) & ~0x8080;
	chset = rmvbufinfo(whatset(wc));

	if(chset & JKANJITREAT){
		if(!r_regularize || chset == JISSUPK) return wc;
		switch(c >> 8){
		case 0x21:
			c &= 0x7f, c = (conv21 - 0x21)[c];
			if(c) return makewch(c, roman_force | G0);
			break;
		case 0x23:
			c &= 0x7f;
			if('0' <= c && c <= '9' ||
			   'A' <= c && c <= 'Z' ||
			   'a' <= c && c <= 'z') /* or: isalnum(c) */
				return makewch(c, roman_force | G0);
			break;
		}
		return wc;
	} else
	if(chset == JISKANA){
		if(!k_regularize) return wc;
		c &= 0x7f; /* c0x20ȉ肤 */
		if(0x21 <= c && c <= 0x5f){
			c = (convjisk - 0x21)[c];
			return makewch(c ^ ((c & 0x80) ? 0x2180 : 0x2500),
							    jisk_force | G0);
		} else {
			return (c == ' ') ? ctowc(' ') :
					    makewch(GETA, jisk_force | G0);
		}
	} else {
		return wc;
	}
}

 /* designate̕KvꍇĂсAۂɂ */
static	void	desigseq_out(otf, chset, buf_no)
FILE	*otf;
us_int	chset, buf_no;
{
	out_designate_const(chset, buf_no);
	if(chset & SPECIALSET){
		if(chset == JIS90K){
			fputs(SEQMOD, otf);
			goto normalset;
		} else { /* PCKANJI, PCROMAN */
			if(buf_no != G0) goto normalset;
			 /* G0ȊȌꍇJIS78K, JISROMAN */
			putc(ESC, otf), putc(chset == PCKANJI? 'K' : 'H', otf);
		}
	} else {
	normalset:
		putc(ESC, otf);
		if(chset & CHARSET96){
			if(chset & MULBYTECHAR) putc('$', otf);
			putc((int)buf_no - G1 + '-', otf);
		} else {
			if(chset & MULBYTECHAR){
				putc('$', otf);
				if(termch(chset) <= 'B' && buf_no == G0 &&
				   !desig4byte) goto nobufnmchar;
			}
			putc((int)buf_no - G0 + '(', otf);
		nobufnmchar:
			;
		}
		 /* o^ςݑ2ԕ2/1̐}`(94̂̂) */
		if(termch(chset) & 0x80) putc('!', otf);

		putc(termch(chset) & ~0x80, otf);
	}
}

 /* invoke̕KvꍇɂĂсAۂɂ */
static	void	invkseq_out(otf, buf_no, glr)
FILE	*otf;
us_int	buf_no, glr;
{
	if(glr == GL){
		out_invoke(buf_no, GL);
		 /* 2萔ɂR[hfc */
		switch(buf_no){
		case G0:
			putc(SI, otf); break;
		case G1:
			putc(SO, otf); break;
		default:
			putc(ESC, otf), putc((int)buf_no - G2 + 'n', otf);
			break;
		}
	} else {
		out_invoke(buf_no, GR);
		putc(ESC, otf), putc('~' + G1 - (int)buf_no, otf);
	}
}

 /* chset[}Zbgłꍇg ͕]
    designateinvoke̕Kv𒲂ׁA΂ */
#define	romanG0GLseq_out(otf, chset)				\
	do {							\
		if(Curdesig(WRSTAT, G0) != (chset)){		\
			out_designate_const(chset, G0);		\
			if(chset & SPECIALSET){ /* PCROMAN */	\
				fputs("\033H", otf);		\
			} else {				\
				fputs("\033(", otf);		\
				putc(termch(chset), otf);	\
			}					\
		}						\
		if(Curbufno(WRSTAT, GL) != G0){			\
			out_invoke(G0, GL);			\
			putc(SI, otf);				\
		}						\
	} while(0)

 /* chsetZbg(⏕܂)łꍇg ͕] */
#define	jiskG0GLseq_out(otf, chset)				\
	do {							\
		if(Curdesig(WRSTAT, G0) != (chset)){		\
			out_designate_const(chset, G0);		\
			if(chset & SPECIALSET){			\
				if(chset == JIS90K){		\
					fputs(SEQMOD, otf);	\
					goto normk;		\
				} else { /* PCKANJI */		\
					fputs("\033K", otf);	\
				}				\
			} else {				\
			normk:					\
				fputs("\033$", otf);		\
				if(chset == JISSUPK || desig4byte) \
					putc('(', otf);		\
				putc(termch(chset), otf);	\
			}					\
		}						\
		if(Curbufno(WRSTAT, GL) != G0){			\
			out_invoke(G0, GL);			\
			putc(SI, otf);				\
		}						\
	} while(0)

 /* ʓIȐ}`ZbgwpBdesignateinvoke̕Kv𒲂ׁA΂
    SS2SS3fƂ̂ŁA2Agpɂ͒ӁBAASS2
    f̂͑3SNGLSFTĂ鎞̂ */
static	void	desinvkseq_out(otf, chset, buf_no, glr)
FILE	*otf;
us_int	chset, buf_no, glr; /* SNGLSFT̃rbgbuf_noĂ */
{
	if(buf_no & SNGLSFT){
		us_int	true_bufno;

		switch(buf_no){
		case G2_SS8bit:
		case G2_SS7bit:
			true_bufno = G2; break;
		default:
			true_bufno = G3; break;
		}
		if(Curdesig(WRSTAT, true_bufno) != chset)
			desigseq_out(otf, chset, true_bufno);
		switch(buf_no){
		case G2_SS8bit:
			putc(SS2, otf); break;
		case G2_SS7bit:
			fputs("\033N", otf); break;
		case G3_SS8bit:
			putc(SS3, otf); break;
		default: /* case G3_SS7bit: */
			fputs("\033O", otf); break;
		}
	} else {
		if(Curdesig(WRSTAT, buf_no) != chset)
			desigseq_out(otf, chset, buf_no);
		if(Curbufno(WRSTAT, glr) != buf_no)
			invkseq_out(otf, buf_no, glr);
	}
}

static	void	undesig_G1_to_G3()
{
	int	buf_no;

	for(buf_no = G1; buf_no <= G3; ++buf_no)
		out_designate_const(UNK_SET, buf_no);
}

static	void	ctlsetchar_out(c, otf)
FILE	*otf;
us_int	c;
 /* c0x20, 0x7f, 0xa0, 0xffŁAsetCHARSET96̏ꍇ͗v */
{
	switch(c){
	case ' ':
		if(redsg_on_spc_out & UNDESIG_G123) undesig_G1_to_G3();
		if((redsg_on_spc_out & ROMAN_G0GL) ||
		   (Curset(WRSTAT, GL) & CHARSET96))
			goto romandesg;
		break;
	case '\t':
		if(redsg_on_spc_out & UNDESIG_G123) undesig_G1_to_G3();
		if(redsg_on_spc_out & ROMAN_G0GL) goto romandesg;
		break;
	case '\n':
		if(o_eolcr) c = '\r';
		 else if(o_eolcnv) ctlsetchar_out('\r', otf);
		/* FALLTHROUGH */
	case '\r': case '\f':
		if(redsg_on_cr_out & UNDESIG_G123) undesig_G1_to_G3();
		if(redsg_on_cr_out & ROMAN_G0GL) goto romandesg;
		break;
	case 0x7f:
		if(redsg_on_ctl_out & UNDESIG_G123) undesig_G1_to_G3();
		if((redsg_on_ctl_out & ROMAN_G0GL) ||
		   (Curset(WRSTAT, GL) & CHARSET96))
			goto romandesg;
		break;
	default:
		if(!(c & 0x80)){
			if(redsg_on_ctl_out & UNDESIG_G123) undesig_G1_to_G3();
			if(redsg_on_ctl_out & ROMAN_G0GL){
			romandesg:
				if(!(Curset(WRSTAT, GL) & ROMANSET))
					romanG0GLseq_out(otf, roman_force);
			}
		} else {
		  /* 0x80ȏɂĂ͉L̑[uȊOƂ肠lȂ */
			if((c == 0xa0 || c == 0xff) &&
			   (Curset(WRSTAT, GR) & CHARSET96)){
				desigseq_out(otf,
					roman_force, Curbufno(WRSTAT, GR));
				 /* 96ZbgłȂችł */
			}
		}
	}
	putc((int)c, otf);
}

static	void	wchar_out(otf, c, chset, buf_no)
 /* {ꕶ̏o͂ɗp */
FILE	*otf;
us_int	c, chset, buf_no;
{
	us_int	d;

	desinvkseq_out(otf, chset, buf_no, (c & 0x8080) ? GR : GL);
	d = c >> 8;
	if(d) (putc((int)d, otf), c &= 0xff);
	putc((int)c, otf);
}

 /* {ꕶo͗pB{ꕶSS2, SS3̎ȊOł͏1oCg
    ǂ܂Ă */
static	void	nonjset_out(otf, c, chset, buf_no)
FILE	*otf;
us_int	c, chset, buf_no;
{
	switch(nonjset){
	case NONJ_Preserve:
		if((chset & CHARSET96) && buf_no == G0) buf_no = G1;
		wchar_out(otf, c, chset, buf_no);
		 /* buf_noSNGLSFTĂꍇGL/GR̋ʂ͎gȂ */
		break;
	case NONJ_G0GL:
		if(chset & CHARSET96){
			wchar_out(otf, c & ~0x8080, chset, G1);
		} else {
			goto w_out_G0GL;
		}
		break;
	case NONJ_CTtype:
		if(chset & CHARSET96){
			goto w_out_G1GR;
		} else {
			goto w_out_G0GL;
		} /* NOTREACHED */
		break;
	case NONJ_JP2type:
		if(chset & CHARSET96){
			wchar_out(otf, c & ~0x8080, chset, G2_SS7bit);
		} else {
			goto w_out_G0GL;
		} /* NOTREACHED */
		break;
	default: /* NONJ_EUCtype */
		if(chset & (MULBYTECHAR | CHARSET96)){
		 /* SS2o͂MSkanjiȂǂ̏ꍇA{ꕶ2oCg
		    Ă邱Ƃ */
		w_out_G1GR:
			wchar_out(otf,
				  c | ((c >> 8) ? 0x8080 : 0x80), chset, G1);
		} else
	     /*	if(chset & CHARSET96){
			wchar_out(otf,
			    c | ((c >> 8) ? 0x8080 : 0x80), chset, G2_SS8bit);
		} else */ {
		w_out_G0GL:
			wchar_out(otf, c & ~0x8080, chset, G0);
		}
		break;
	}
}

static	void	iso_wputc(wc, otf)
FILE	*otf;
wchar4b	wc;
{
/* j		94P(JISJi)	JISJi  96͂G1
			94		  (EUĈƂ96PG2~)
	EUC	G0	JISG3	G2	G0=ASC G1=83K G2=KANA G3=SUPK GLG0 GRG1
			ȊOG1
	JIS1	G0	G0	G0	G0=ASC G1=KANA G2=G3=UK	GLG0 GRG1
	JIS2	G0	G0	G1(GL)	G0=ASC G1=KANA G2=G3=UK GLG0 GRG1
	JIS3	G0	G0	G1	G0=ASC G1=KANA G2=G3=UK GLG0 GRG1
	Comp1	G0	G0	G1	G0=ASC G1=LATN G2=G3=UK GLG0 GRG1
	(Comp2	G0	G1	G1
 IvV: E/J
	(E,J)	{ȊO=̒ʂ/ۑ/G0GL(96G1)
		TAB,SP=G0GL/ CR=G0GL/ OTHERCTL=G0GL/
			20 7f a0 ffɂĂCHARSET96ɒ
	(J)	(=G0/G1) KANA=G0/G1GL/G1GR G1=LATIN/KANA
 */
	us_int	c, chset, buf_no;

	c = wctoc(wc);
	chset = whatset(wc), buf_no = gbufno(chset), chset = rmvbufinfo(chset);

	if(chset & ROMANSET){
	 /* ɂ͂悭̂Ŋ֐Ăяo͎g킸}NɂĂ */
		if(Curset(WRSTAT, GL) != chset)	romanG0GLseq_out(otf, chset);
		putc((int)c & 0x7f, otf);
	} else
	if(chset & JKANJITREAT){ /* ֐ĂяoɂȂ */
		if(Curset(WRSTAT, GL) != chset) jiskG0GLseq_out(otf, chset);
		c &= ~0x8080;
		put2c(c, otf);
	} else
	if(!chset){
		ctlsetchar_out(c, otf); /* o_eolcnv, o_eolcrl */
	} else
	if(chset == JISKANA){
		c &= 0x7f;
		if((c <= 0x20 || 0x60 <= c) && outtype_iso != IOtype_PC){
			iso_wputc(makewch(GETA, jisk_force | G0), otf);
			return;
		}
		switch(jkana_out){
		case JKANA_G1GR:
			if(outtype_iso == IOtype_PC &&
			 /* o͂PC^ȂJi͉pZbgG0GLɎw
			    óBJKANA_G1GL̏ꍇ */
			   !(Curset(WRSTAT, GL) & ROMANSET) &&
			   Curset(WRSTAT, GL) != chset)
				desinvkseq_out(stdout, roman_force, G0, GL);
			if(Curset(WRSTAT, GR) != chset)
				desinvkseq_out(otf, chset, G1, GR);
			putc((int)c | 0x80, otf);
			break;
		case JKANA_G1GL:
			if(Curset(WRSTAT, GL) != chset){
				if(outtype_iso == IOtype_PC &&
				   !(Curset(WRSTAT, GL) & ROMANSET))
					desigseq_out(stdout, roman_force, G0);
					 /* łǂGLG1Ăяo񂾂
					    invoke͖ */
				desinvkseq_out(otf, chset, G1, GL);
			}
			putc((int)c, otf);
			break;
		default: /* case JKANA_G0GL: */
			if(Curset(WRSTAT, GL) != chset)
				desinvkseq_out(otf, chset, G0, GL);
			putc((int)c, otf);
			break;
		}
	} else {
		nonjset_out(otf, c, chset, buf_no);
	}
}

static	void	eucj_wputc(wc, otf)
FILE	*otf;
wchar4b	wc;
{
	us_int	c, chset, buf_no;

	c = wctoc(wc);
	chset = whatset(wc), buf_no = gbufno(chset), chset = rmvbufinfo(chset);

	if(chset & ROMANSET){ /* [}̌Ăяo͏G0GL */
		if(Curset(WRSTAT, GL) != chset)
			desinvkseq_out(otf, chset, G0, GL);
		putc((int)c & 0x7f, otf);
	} else
	if(chset & JKANJITREAT){ /* E⏕ */
		if(chset == JISSUPK){
			if(Curdesig(WRSTAT, G3) != JISSUPK)
				desigseq_out(otf, JISSUPK, G3);
			putc(SS3, otf);
		} else {
			if(Curset(WRSTAT, GR) != chset)
				desinvkseq_out(otf, chset, G1, GR);
		}
		c |= 0x8080;
		put2c(c, otf);
	} else
	if(!chset){
		ctlsetchar_out(c, otf); /* o_eolcnv, o_eolcrl */
	} else
	if(chset == JISKANA){
		c |= 0x80;
		if(c <= 0xa0 || 0xe0 <= c){
			eucj_wputc(makewch(GETA, jisk_force | G0), otf);
			return;
		}
		if(Curdesig(WRSTAT, G2) != JISKANA)
			desigseq_out(otf, JISKANA, G2);
		putc(SS2, otf);
		putc((int)c, otf);
	} else {
		nonjset_out(otf, c, chset, buf_no);
	}
}

static	void	mscode_wputc(wc, otf)
FILE	*otf;
wchar4b	wc;
{
	register us_int	c, d;
	us_int	chset;

	c = wctoc(wc);
	chset = rmvbufinfo(whatset(wc));

	if(chset & ROMANSET){
		putc((int)c & 0x7f, otf);
	} else
	if(chset & JKANJITREAT){ /* E⏕ */
		int	msupaddparam;

		c &= ~0x8080;
		if(chset == JISSUPK){
			if(0x3b00 <= c) goto geta_out;
			msupaddparam = 0xf0 - (0x21 >> 1);
		} else {
			msupaddparam = (c < 0x5f00) ?
				0x81 - (0x21 >> 1) : 0xe0 - (0x5f >> 1);
		}
		d = c & 0x1ff;
		d += (d < 0x100 ? (--msupaddparam, 0x9f - 0x21) :
		      d <= 0x15f ? 0x40 - 0x121 : 0x80 - 0x160);
		putc((int)(c >> 9) + msupaddparam, otf), putc((int)d, otf);
	} else
	if(!chset){
		if(c == '\n'){
			if(o_eolcr) c = '\r';
			 else if(o_eolcnv) putc('\r', otf);
		}
		putc((int)c, otf);
	} else
	if(chset == JISKANA){
		c |= 0x80;
		if(c < 0xa1 || 0xdf < c) goto geta_out;
		putc((int)c, otf);
	} else { /* Non-Jset */
	geta_out:
		fputs(GETA_SJ, otf);
	}
}

static	void	do_i_subopt(c)
int	c;
{
	switch(c){
	case 'e': case 'u':
		common_wgetc = iso_wgetc, intype_iso = IOtype_EUC; break;
	case 'j':
		common_wgetc = iso_wgetc, intype_iso = IOtype_JIS; break;
	case 'c':
		common_wgetc = iso_wgetc, intype_iso = IOtype_CT; break;
	case 'P':
		common_wgetc = iso_wgetc, intype_iso = IOtype_PC; break;
	case 'm': case 's':
		common_wgetc = mscode_wgetc; break;
	case 'i':
		common_wgetc = muleint_wgetc; break;

	case 't':
		i_eolcnv ^= 1; break;
	case 'z':
		i_igaftctlz ^= 1; break;
	case 'Z':
		i_ignctlz ^= 1; break;
	case 'l':
		i_linemode ^= 1; break;
	case 'f':
		i_nobuf ^= 1; break;
	case 'k':
		i_kanajis ^= 1; break;
	default:
		usage();
	}
}

static	void	do_o_subopt(c)
int	c;
{
	switch(c){
	case 'e': case 'u':
		wputc = eucj_wputc; outtype_iso = IOtype_EUC; break;
	case 'j':
		wputc = iso_wputc;  outtype_iso = IOtype_JIS; break;
	case 'c':
		wputc = iso_wputc;  outtype_iso = IOtype_CT;  break;
	case 'P':
		wputc = iso_wputc;  outtype_iso = IOtype_PC;  break;
	case 'm': case 's':
		wputc = mscode_wputc; break;

	case 't':
		o_eolcnv ^= 1; break;
	case 'T':
		o_eolcr ^= 1; break;
	case 'f':
		o_nobuf ^= 1; break;
	default:
		usage();
	}
}

static	void	do_j_subopt(c)
int	c;
{
	switch(c){
	case '@':
		jisk_force = JIS78K; break;
	case 'B':
		jisk_force = JIS83K; break;
	case '+':
		jisk_force = JIS90K; break;
	case 'p':
		jisk_unite ^= 1; break;
	default:
		usage();
	}
}

static	void	do_r_subopt(c)
int	c;
{
	switch(c){
	case 'J':
		roman_force = JISROMAN; break;
	case 'B':
		roman_force = ASCIISET; break;
	case 'p':
		roman_unite ^= 1; break;
	case 'H':
		swnam_as_roman ^= 1; break;
	case '1':
		r_regularize ^= 1; break;
	default:
		usage();
	}
}

static	void	do_k_subopt(c)
int	c;
{
	switch(c){
	case 'I':
		jkana_out = JKANA_G0GL; break;
	case '7':
		jkana_out = JKANA_G1GL; break;
	case '8':
		jkana_out = JKANA_G1GR; break;
	case '2':
		k_regularize ^= 1; break;
	default:
		usage();
	}
}

static	void	do_c_subopt(c)
int	c;
{
	switch(c){
	case 'e':
		redsg_on_eof_out ^= ROMAN_G0GL; break;
	case 'l':
		redsg_on_cr_out ^= ROMAN_G0GL; break;
	case 'L':
		redsg_on_cr_out ^= UNDESIG_G123; break;
	case 's':
		redsg_on_spc_out ^= ROMAN_G0GL; break;
	case 'S':
		redsg_on_spc_out ^= UNDESIG_G123; break;
	case 'o':
		redsg_on_ctl_out ^= ROMAN_G0GL; break;
	case 'O':
		redsg_on_ctl_out ^= UNDESIG_G123; break;
	default:
		usage();
	}
}

static	void	do_C_subopt(c)
int	c;
{
	switch(c){
	case 'l':
		redsg_on_cr_in ^= 1; break;
	case 's':
		redsg_on_spc_in ^= 1; break;
	case 'o':
		redsg_on_ctl_in ^= 1; break;
	default:
		usage();
	}
}

static	void	do_f_subopt(c)
int	c;
{
	switch(c){
	case 'E':
		nonjset = NONJ_EUCtype; break;
	case 'I':
		nonjset = NONJ_G0GL; break;
	case 'C':
		nonjset = NONJ_CTtype; break;
	case '2':
		nonjset = NONJ_JP2type; break;
	case 'p':
		nonjset = NONJ_Preserve; break;
	default:
		usage();
	}
}

static	void	do_u_subopt(c)
int	c;
{
	switch(c){
	case '4':
		desig4byte ^= 1; break;
	default:
		usage();
	}
}

static	void	do_opt(c, optarg)
int	c;
char	*optarg;
{
	void	(*do_subopt_fn)(
#ifdef __WATCOMC__ /* sigh */
			int
#endif
		);

	for(;;){
		switch(c){
		case 's': initstring = optarg; return; /* ڒEo */

		case 'i': do_subopt_fn = do_i_subopt; break;
		case 'o': do_subopt_fn = do_o_subopt; break;
		case 'j': do_subopt_fn = do_j_subopt; break;
		case 'r': do_subopt_fn = do_r_subopt; break;
		case 'k': do_subopt_fn = do_k_subopt; break;
		case 'c': do_subopt_fn = do_c_subopt; break;
		case 'C': do_subopt_fn = do_C_subopt; break;
		case 'f': do_subopt_fn = do_f_subopt; break;
		case 'u': do_subopt_fn = do_u_subopt; break;
		default:
			usage();
		}
		for(; *optarg && *optarg != ','; optarg++)
			(*do_subopt_fn)(*optarg);
		if(!*optarg) break;
		c = *++optarg;
		if(!*++optarg) usage();
	}
}

static	void	alloc_iobufs()
{ /* ibufobuf蓖ĂꂸNULL̂܂܂ɂȂĂG[Ƃ͂Ȃ */
	if(o_nobuf){
		if(!i_nobuf){ /* ibuf */
			ibuf = malloc(ibufsiz = BIGBUFSIZ);
			if(ibuf == NULL) ibuf = malloc(ibufsiz >>= 1);
		}
	} else { /* ȂƂobuf͂ */
		obuf = malloc(obufsiz = BIGBUFSIZ);
		if(obuf == NULL) obuf = malloc(obufsiz >>= 1);
		if(obuf == NULL || i_nobuf) return;

		 /* ibuf */
		ibuf = malloc(ibufsiz = obufsiz);
		if(ibuf == NULL){
			ibufsiz -= (obufsiz >>= 1);
			ibuf = obuf + obufsiz;
		 /* ƂreallocɂȂ */
		}
	}
}

main(ac, av)
int	ac;
char	*av[];
{
	int	c, err_status = 0;

	extern	int	optind, opterr;
	extern	char	*optarg;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif
	opterr = 0;
	while(EOF != (c = getopt(ac, av, "i:o:j:r:k:c:C:f:u:s:"))){
		do_opt(c, optarg);	 /* Cusage() */
	}
	av += optind, ac -= optind;
#ifdef MSDOS
	i_igaftctlz ^= i_eolcnv;
#else
	i_ignctlz ^= i_eolcnv;
#endif

	 /* o̓R[h̎ʂɂ */
	switch(outtype_iso){
	case IOtype_CT:
		desig4byte ^= 1;		/* -u4 */
		if(jkana_out == JKANA_UNDEF)
			jkana_out = JKANA_G1GR; /* -k8 */
		if(nonjset == NONJ_UNDEF)
			nonjset = NONJ_CTtype;	/* -fC */
		break;
	case IOtype_PC:
		if(jkana_out == JKANA_UNDEF)
			jkana_out = JKANA_G1GR; /* -k8 */
		 /* ȉ͊YPƃIvVȂ */
		jisk_force = PCKANJI, roman_force = PCROMAN;
		break;
	}
	if(jkana_out == JKANA_UNDEF) jkana_out = JKANA_G0GL;
	if(nonjset == NONJ_UNDEF) nonjset = NONJ_Preserve;   /* default */

	 /* o̓R[h̓IvVŊɌ܂ĂBZbg̏Ԃ
	    (STDSTAT, WRSTAT)B܂RDSTATɏԂ߂WRSTAT, STDSTAT
	    ɃRs[ARDSTAT͌ŉ߂ċ߂ */
	in_designate_to_thebuf(
		outtype_iso == IOtype_CT ? ASCIISET : roman_force, G0);
	in_designate_to_thebuf(
		outtype_iso == IOtype_EUC ? jisk_force :
		outtype_iso == IOtype_CT ? LATIN1SET : JISKANA, G1);
	if(wputc == mscode_wputc) kanjitreatflg = MULBYTECHAR; /* ł */
	setinit(initstring); /* RDSTATKɕς */
	 /* ܂łł܂RDSTATɏԂ܂̂ŃRs[ */
	memcpy(&iostat[STDSTAT], &iostat[RDSTAT], sizeof(struct iosetinfo));
	memcpy(&iostat[WRSTAT], &iostat[STDSTAT], sizeof(struct iosetinfo));
	 /* RDSTAT͌ŉ߂Č߂ */

	if(r_regularize){
		switch(roman_force){
		case JISROMAN:
			conv21[0x41 - 0x21] = '\0', conv21[0x31 - 0x21] = '~';
			 /* FALLTHROUGH */
		case PCROMAN:
			conv21[0x40 - 0x21] = '\0', conv21[0x6f - 0x21] = '\\';
			break;
		}
	}

	fsetbin(stdout);
	alloc_iobufs(); /* ibuf, obuf蓖āA傫ibufsizobufsiz */
	if(o_nobuf){
		setbuf(stdout, NULL);
	} else {
		if(obuf != NULL && 0 != setfbuf(stdout, obuf, obufsiz))
			cantbuf();
	}

	if(!ac){
		yakc(stdin);
	} else {
		for(; ac; ac--, av++){
			if(**av == '-' && !av[0][1]){
				yakc(stdin);
				clearerr(stdin);
			} else {
				FILE	*f;

				if(NULL == (f = fopen(*av, "r"))){
					cmd_errmsg(s_conv_to_unix_format(*av));
					fputs(": Can't open\n", stderr);
					err_status = 1;
					continue;
				}
				yakc(f);
				fclose(f);
			}
		}
	}

	/* if(redsg_on_eof_out & UNDESIG_G123){} */ /* Ӗ */
	if((redsg_on_eof_out & ROMAN_G0GL) && !(Curset(WRSTAT,GL) & ROMANSET)){
		desinvkseq_out(stdout, roman_force, G0, GL);
	} /* ŌROMANIĂ */
	if(fclose(stdout) != 0 && !isatty(fileno(stdout))){
		cmd_errmsg("Can't write to stdout\n"), exit(1);
	}
	return err_status;
}

static	void	setinit(s)
char	*s; /* s: "1b2442c" */
{
	us_int	c, d, l;

	if(s == NULL) return;

	l = strlen(s);
	if(l & 1){
	error:
		cmd_errmsg("Error in initial string\n"), exit(1);
	}
	if(l > (UBUFSIZ - 1) * 2){
		cmd_errmsg("Initial string too long\n"), exit(1);
	}
	ungetch(uEOF);
	while(l){
		d = s[--l];
		if(is_xdigit(d)) c = ctoi(d); else goto error;
		c = s[--l];
		if(is_xdigit(c)) c = ctoi(c); else goto error;
		c <<= 4, c |= d;
		ungetch(c);
	}
	while(wEOF != iso_wgetc((FILE *)NULL)); /* RDSTAT낢ς */
}

static	void	yakc_setbuf(inf)
register FILE	*inf;
{
#ifdef MSDOS
	fsetbin(inf);
#endif
	if(i_nobuf){
		setbuf(inf, NULL);
	} else {
		if(ibuf != NULL && 0 != setfbuf(inf, ibuf, ibufsiz)) cantbuf();
		 /* obt@t@CԂŎ荇ɂȂ邱Ƃ͂Ȃ */
	}
	unget_sp = 0; /* Ô */
}

static	void	yakc_intro(inf)
register FILE	*inf;
{ /* ̓R[hȂǓ͂̏ */
	register us_int	c;

	 /* ̓R[ȟ */
	if(common_wgetc != NULL){
		wgetc = common_wgetc;
	} else
	if(initstring != NULL){
		wgetc = iso_wgetc;
	} else {
		 /* ̎_wgetc͖ ܂܂wgetc͎gȂ */
		for(;;){
			c = getch(inf); /* us_intɂEOF0xff */
			if(0x21 <= c && c <= 0x7e){
				(*wputc)(makewch(c, roman_force | G0), stdout);
			} else switch(c){ /* 0x00`0x20, 0x7f`0xff, EOF */
			case ESC:
				if(peekch(inf) != '[') goto decide;
				goto other_ch;
			case '\n':
				if(i_linemode) goto decide;
				goto other_ch;
			case '\r':
				if(i_linemode) goto decide;
				if(i_eolcnv && (c = getch(inf)) != '\n')
					(ungetch(c), c = '\n');
				goto other_ch;
			case SI: case SO: case ASS2: case ASS3:
				goto decide;
			case DOSEOF:
				if(i_igaftctlz) goto decide;
				if(i_ignctlz) continue;
				goto other_ch;
			default: /* ܂EOF */
				if(0x80 <= c) goto decide;
				 /* FALLTHROUGH */
			other_ch:
				(*wputc)(ctowc(c), stdout);
				continue;
			}
		}
	decide:
		ungetch(c);
		decide_incode(inf); /* wgetcɉ */
	} /* Ɠ̓R[h܂ */

	memcpy(&iostat[RDSTAT], &iostat[STDSTAT], sizeof(struct iosetinfo));
	 /* setinit()ĂԂSTDSTATRs[ */
	if(wgetc == iso_wgetc && initstring == NULL){
#if 0 /* ͕sv? */
		in_designate_to_thebuf(
			intype_iso == IOtype_CT ? ASCIISET : roman_force, G0);
#endif
		in_designate_to_thebuf(
			intype_iso == IOtype_EUC ? jisk_force :
			intype_iso == IOtype_CT ? LATIN1SET : JISKANA, G1);
	}
	if(r_regularize || k_regularize){
		plain_wgetc = wgetc, wgetc = special_wgetc;
	}
}

#define AFTER_ESC 0x20
#define AFTER_SS2 0x10

static	void	decide_incode(inf)
register FILE	*inf;
{
	register us_int	c;
	int	eucj_rest = 0, jis_rest = 0, mscode_rest = 0, muleint_rest = 0;
	int	tmp_sp, possible_codes = 4;
	int	esc_found = 0; /* EUCJJIS̋ʂȂ̔p */
	int	mintk_found = 0; /* MULEINTMSCODEʂȂ̔ڈ */

	tmp_sp = UBUFSIZ;
	for(;;){
		if(possible_codes < 2 || !tmp_sp) break;
		if(uEOF == (unget_buf[--tmp_sp] = c = getch(inf)) ||
		   i_linemode && (c == '\r' || c == '\n') ||
		   i_igaftctlz && c == DOSEOF){
			if(eucj_rest) (eucj_rest = -1, --possible_codes);
			if(jis_rest) (jis_rest = -1, --possible_codes);
			if(mscode_rest) (mscode_rest = -1, --possible_codes);
			if(muleint_rest) (muleint_rest = -1, --possible_codes);
			break;
		} /* tmp_sp < unget_sp ƂȂ邱Ƃ͂Ȃ */

		switch(mscode_rest){
		case AFTER_ESC:
			if(c == '['){
				goto mscode_yet_possible;
			} else {
				goto mscode_impossible;
			}
			break;
		case 1:
			if(0x40 <= c && c <= 0xfc && c != 0x7f){
			mscode_yet_possible:
				mscode_rest = 0;
			} else {
				goto mscode_impossible;
			}
			break;
		case 0:
			if(c == ESC){
				mscode_rest = AFTER_ESC;
			} else
			if(!(c & 0x80) && c != SI && c != SO ||
			   0xa0 <= c && c <= 0xdf){
				/* nothing */
			} else
			if(0x81 <= c && c <= 0xfc){
				++mscode_rest;
			} else {
			mscode_impossible:
				mscode_rest = -1, --possible_codes;
			}
			break;
		}
		switch(eucj_rest){
		case -1:
			break;
		case 0:
			if(c == ESC){
				esc_found = 1;
				eucj_rest = AFTER_ESC;
			} else
			if(!(c & 0x80) && c != SI && c != SO){
				/* nothing */
			} else
			if(0xa1 <= c && c <= 0xfe){
				++eucj_rest;
			} else
			if(c == SS2){
				eucj_rest = AFTER_SS2;
			} else
			if(c == SS3){
				eucj_rest = 2;
			} else {
			eucj_impossible:
				eucj_rest = -1, --possible_codes;
			}
			break;
		case AFTER_ESC:
			if(' ' <= c && c <= 0x7e){
				goto eucj_yet_possible;
			} else {
				goto eucj_impossible;
			}
			break;
		case AFTER_SS2:
			if(0xa1 <= c && c <= 0xdf){
			 /* ʒ2oCgڂ0xa0̉\͔l
			    default caselAmuleint̔łl */
			eucj_yet_possible:
				eucj_rest = 0;
			} else {
				goto eucj_impossible;
			}
			break;
		default: /* case 1, 2 */
			if(0xa1 <= c && c <= 0xfe){
				--eucj_rest;
			} else {
				goto eucj_impossible;
			}
			break;
		}
		switch(jis_rest){
		case 0:
			if(!(c & 0x80) || 0xa1 <= c && c <= 0xdf){
				/* nothing */
			} else {
				--jis_rest, --possible_codes;
			}
			break;
		}
		switch(muleint_rest){
		case -1:
			break;
		case 0:
			switch(c){
			case MULE_KANA_RDNG:
				muleint_rest = AFTER_SS2; break;
			case MULE_KNJ_RDNG:
			case MULE_SUPK_RDNG:
				mintk_found = 1, muleint_rest = 2; break;
			default:
				if(!(c & 0x80)) break;
			muleint_impossible:
				muleint_rest = -1, --possible_codes;
			}
			break;
		case AFTER_SS2:
			if(0xa1 <= c && c <= 0xdf){
				muleint_rest = 0;
			} else {
				goto muleint_impossible;
			}
			break;
		default: /* case 1, 2 */
			if(0xa1 <= c && c <= 0xfe){
				--muleint_rest;
			} else {
				goto muleint_impossible;
			}
			break;
		}
	}

	bcopy((char *)(unget_buf + tmp_sp), (char *)(unget_buf + unget_sp),
			sizeof(us_int) * (UBUFSIZ - tmp_sp));
	unget_sp += UBUFSIZ - tmp_sp;
	if(eucj_rest >= 0){
		wgetc = iso_wgetc;
		intype_iso = (jis_rest < 0 || !esc_found || !i_kanajis) ?
						IOtype_EUC : IOtype_JIS;
		 /* IOtype_EUCɂJISłȂ̕^N^O
		    oĂꍇɍ */
	} else
	if(jis_rest >= 0){
		wgetc = iso_wgetc, intype_iso = IOtype_JIS;
	} else
	if(mscode_rest >= 0){
		wgetc = (muleint_rest >= 0 && mintk_found ?
					muleint_wgetc : mscode_wgetc);
	} else
	if(muleint_rest >= 0){
		wgetc = muleint_wgetc;
	} else {
		wgetc = iso_wgetc;
		intype_iso = (esc_found ? IOtype_JIS : IOtype_EUC);
	}
}

static	void	yakc(inf)
register FILE	*inf;
{
	wchar4b	c;

	yakc_setbuf(inf);
	if(!i_linemode){
		yakc_intro(inf); /* œ̓R[hm */

		 /* ̓R[h̊m܂ł͂ʂ炸
		    ̂܂܏oĂ̂Œ */
		while(wEOF != (c = (*wgetc)(inf))){
			(*wputc)(c, stdout);
		}
	} else {
		for(;;){
			yakc_intro(inf); /* œ̓R[hm */
			for(;;){
				if(wEOF == (c = (*wgetc)(inf))) return;
				(*wputc)(c, stdout);
				if(c == ctowc('\n') || c == ctowc('\r'))
					break;
			}
		}
	}
}
